%define dprog     dspamd
%define wprog     dspamwebd


Summary:          An open-source, freely available anti-spam solution
Name:             dspam
Version:          3.9.0
Release:          3%{?dist}%{?pext}
License:          GPL
Group:            System Environment/Daemons
Source0:          http://downloads.sourceforge.net/project/%{name}/%{name}/%{name}-%{version}/%{name}-%{version}.tar.gz
Source1:          %{dprog}.init
Source2:          %{wprog}.init
Source3:          %{dprog}.wrapper
Source4:          %{wprog}.py
Source5:          %{name}.logrotate
Source6:          %{name}.sysconfig
Source7:          %{name}.conf
Source8:          %{name}.cron
Source9:          %{name}.webcfg
Patch0:           %{name}-3.9.0-build.patch
Patch1:           %{name}-3.9.0-config.patch
Patch2:           %{name}-3.9.0-webui.patch
Patch3:           %{name}-3.8.0-admin_stats.patch
Patch4:           %{name}-3.9.0-sql_path.patch
Patch5:           %{name}-3.9.0-pgsql_fixes.patch
# http://www.shapeshifter.se/2009/03/03/dspam-converting-from-the-hash-driver-to-mysql-driver/
Patch10:          %{name}-3.8.0-2sql_virtuser.patch
URL:              http://%{name}.nuclearelephant.com/
Buildroot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:           The DSPAM Project <dspam-user@lists.sourceforge.net>
Requires:         %{name}-libs = %{version}-%{release}
Requires:         crontabs
Requires(pre):    /usr/sbin/groupadd /usr/sbin/useradd
Requires(post):   /sbin/chkconfig
Requires(preun):  /sbin/chkconfig /sbin/service
Requires(postun): /sbin/service
BuildRequires:    mysql-devel openldap-devel postgresql-devel

%description
DSPAM is an open-source, freely available anti-spam solution designed to
combat unsolicited commercial email using advanced statistical analysis.
In short, DSPAM filters spam by learning what spam is and isn't. It does
this by learning each user's individual mail behavior. This allows DSPAM
to provide highly accurate, personalized filtering for each user on even
large systems and provides an administratively maintenance free solution
capable of learning each user's email behaviors with few false positives.


%package          devel
Summary:          Development tools for DSPAM
Group:            Development/Libraries
Requires:         %{name}-libs = %{version}-%{release}
Requires:         openldap-devel
Obsoletes:        lib%{name}-devel < %{version}-%{release}

%description      devel
The %{name}-devel package contains the static libraries and header files
for developing software using DSPAM.


%package          libs
Summary:          The DSPAM core processing engine
Group:            System Environment/Libraries
Obsoletes:        lib%{name} < %{version}-%{release}

%description      libs
Libdspam is the DSPAM core processing engine, which provides all critical
spam filtering functions. It is embedded into other DSPAM components (such
as the agent) and is responsbile for the actual filtering logic.


%package          mysql
Summary:          The MySQL storage driver for DSPAM
Group:            System Environment/Libraries
Requires:         %{name} = %{version}-%{release}
Requires:         %{_bindir}/mysql %{_bindir}/mysql_config

%description      mysql
The %{name}-mysql package contains the DSPAM storage driver for MySQL
database backends.


%package          pgsql
Summary:          The PosgreSQL storage driver for DSPAM
Group:            System Environment/Libraries
Requires:         %{name} = %{version}-%{release}
Requires:         %{_bindir}/psql

%description      pgsql
The %{name}-pgsql package contains the DSPAM storage driver for PostgreSQL
database backends.


%package          web
Summary:          The DSPAM Web Interface
Group:            Applications/Internet
Requires:         %{name} = %{version}-%{release}
Requires:         httpd python(Twisted.Core) python(Twisted.Web)
Requires:         %{_bindir}/twistd

%description      web
The %{name}-web package contains the DSPAM Web User Interface (UI) which
is designed to allow end-users to review their spam quarantine and history,
graphs, and to delete their spam permanently. They can also optionally use
the quarantine to perform all of their training. The UI also includes some
basic administrative tools to change settings and manage user quarantines.


%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch10 -p1

# Filter requires
%{__cat} << \_EOF_ >%{name}-req
#!/bin/sh
%{__perl_requires} $* | \
	%{__sed} -e '/perl(configure.pl)/d'
_EOF_

%define __perl_requires %{_builddir}/%{name}-%{version}/%{name}-req
%{__chmod} +x %{name}-req


%build
%configure \
	--sysconfdir=%{_sysconfdir}/%{name}                \
	--with-dspam-home=%{_localstatedir}/spool/%{name}  \
	--with-logdir=%{_localstatedir}/log/%{name}        \
	--enable-shared                                    \
	--enable-static                                    \
	--enable-daemon                                    \
	--enable-external-lookup                           \
	--enable-clamav                                    \
	--enable-debug                                     \
	--enable-syslog                                    \
	--enable-preferences-extension                     \
	--enable-long-usernames                            \
	--enable-large-scale                               \
	--enable-virtual-users                             \
	--with-storage-driver=hash_drv,mysql_drv,pgsql_drv \
	--with-mysql-includes=%{_includedir}/mysql         \
	--with-mysql-libraries=%{_libdir}/mysql

%{__make} %{?_smp_mflags}


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_initrddir}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sysconfdir}/{cron.daily,httpd/conf.d,logrotate.d,sysconfig}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sbindir}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_datadir}/%{name}/scripts
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_datadir}/%{name}/sql/{mysql,pgsql}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_datadir}/%{name}/webui/{cgi-bin,htdocs,server}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_localstatedir}/log/%{name}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_localstatedir}/spool/%{name}/{data,txt}

%{__make} \
	DESTDIR=${RPM_BUILD_ROOT} \
	install

%{__ln_s}    %{_bindir}/%{name}   ${RPM_BUILD_ROOT}%{_sbindir}/%{dprog}
%{__install} -m 0755 %{SOURCE3}   ${RPM_BUILD_ROOT}%{_sbindir}/%{dprog}-wrapper

%{__install} -m 0755 %{SOURCE1}   ${RPM_BUILD_ROOT}%{_initrddir}/%{dprog}
%{__install} -m 0755 %{SOURCE2}   ${RPM_BUILD_ROOT}%{_initrddir}/%{wprog}

%{__install} -m 0644 %{SOURCE5}   ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{name}
%{__install} -m 0644 %{SOURCE6}   ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/%{name}

%{__install} -m 0640 %{SOURCE7}   ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf.d
%{__install} -m 0755 %{SOURCE8}   ${RPM_BUILD_ROOT}%{_sysconfdir}/cron.daily/%{name}

%{__install} -m 0755 contrib/dspam*/*.sh ${RPM_BUILD_ROOT}%{_datadir}/%{name}/scripts
%{__install} -m 0755 scripts/*.pl ${RPM_BUILD_ROOT}%{_datadir}/%{name}/scripts

for DBTYPE in mysql pgsql; do
  %{__install} -m 0644 src/tools.${DBTYPE}_drv/*.sql \
	${RPM_BUILD_ROOT}%{_datadir}/%{name}/sql/${DBTYPE}
done

%{__rm}      -f                   ${RPM_BUILD_ROOT}%{_libdir}/lib*.so.{?,??}
%{__rm}      -f                   ${RPM_BUILD_ROOT}%{_libdir}/%{name}/lib*.so.{?,??}

# Install templates
%{__install} -m 0644 txt/*.txt    ${RPM_BUILD_ROOT}%{_localstatedir}/spool/%{name}/txt

# Install Web UI
%{__install} -m 0640 %{SOURCE9}   ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/webui.conf

%{__ln_s}    %{_bindir}/twistd    ${RPM_BUILD_ROOT}%{_sbindir}/%{wprog}
%{__install} -m 0644 %{SOURCE4}   ${RPM_BUILD_ROOT}%{_datadir}/%{name}/webui/server

pushd webui/cgi-bin
%{__install} -m 0750 *.cgi        ${RPM_BUILD_ROOT}%{_datadir}/%{name}/webui/cgi-bin
%{__install} -m 0640 *.{pl,txt}   ${RPM_BUILD_ROOT}%{_datadir}/%{name}/webui/cgi-bin
%{__install} -m 0640 admins       ${RPM_BUILD_ROOT}%{_datadir}/%{name}/webui/cgi-bin

%{__install} -m 0640 *.prefs      ${RPM_BUILD_ROOT}%{_localstatedir}/spool/%{name}
%{__ln_s}    %{_localstatedir}/spool/%{name}/default.prefs \
	${RPM_BUILD_ROOT}%{_datadir}/%{name}/webui/cgi-bin

%{__cp}      -r      templates    ${RPM_BUILD_ROOT}%{_datadir}/%{name}/webui/cgi-bin
popd

pushd webui
%{__install} -m 0644 htdocs/*     ${RPM_BUILD_ROOT}%{_datadir}/%{name}/webui/htdocs
popd

find ${RPM_BUILD_ROOT}%{_datadir}/%{name}/webui -type f -name "Makefile*" \
	-exec %{__rm} -f {} \;


%pre
if ! getent group  %{name} >/dev/null 2>&1; then
  /usr/sbin/groupadd -r %{name}
fi
if ! getent passwd %{name} >/dev/null 2>&1; then
  /usr/sbin/useradd  -r -g %{name} -G mail \
	-d %{_localstatedir}/spool/%{name} \
	-c "DSPAM Service user"            \
	-s /bin/bash %{name}
fi
exit 0			# Always pass


%post
/sbin/chkconfig --add %{dprog}

%post libs -p /sbin/ldconfig

%post mysql -p "/sbin/ldconfig -n %{_libdir}/%{name}"

%post pgsql -p "/sbin/ldconfig -n %{_libdir}/%{name}"

%post web
/sbin/chkconfig --add %{wprog}


%preun
if [ $1 -eq 0 ]; then	# Remove
  /sbin/service %{dprog} stop >/dev/null 2>&1
  /sbin/chkconfig --del %{dprog}
fi

%preun web
if [ $1 -eq 0 ]; then	# Remove
  /sbin/service %{wprog} stop >/dev/null 2>&1
  /sbin/chkconfig --del %{wprog}
fi


%postun
if [ $1 -ge 1 ]; then	# Upgrade
  /sbin/service %{dprog} condrestart >/dev/null 2>&1 || :
fi

%postun libs -p /sbin/ldconfig

%postun mysql -p "/sbin/ldconfig -n %{_libdir}/%{name}"

%postun pgsql -p "/sbin/ldconfig -n %{_libdir}/%{name}"

%postun web
if [ $1 -ge 1 ]; then	# Upgrade
  /sbin/service %{wprog} condrestart >/dev/null 2>&1 || :
fi


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc CHANGELOG LICENSE README* RELEASE* UPGRADING
%doc --parents doc/*.txt
%attr(755,root,root) %dir %{_sysconfdir}/%{name}
%attr(640,root,%{name}) %config(noreplace) %{_sysconfdir}/%{name}/%{name}.conf
%config(noreplace) %{_sysconfdir}/cron.daily/%{name}
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%{_initrddir}/%{dprog}
%{_bindir}/cssclean
%{_bindir}/csscompress
%{_bindir}/cssconvert
%{_bindir}/cssstat
%{_bindir}/dspam_2sql
%{_bindir}/dspam_admin
%{_bindir}/dspam_clean
%{_bindir}/dspam_crc
%{_bindir}/dspam_dump
%{_bindir}/dspam_logrotate
%{_bindir}/dspam_merge
%{_bindir}/dspam_stats
%{_bindir}/dspam_train
%attr(2710,%{name},mail) %{_bindir}/%{name}
%attr(2710,%{name},mail) %{_bindir}/dspamc
%{_libdir}/%{name}/libhash_drv.so
%{_libdir}/%{name}/libhash_drv.so.*
%{_sbindir}/%{dprog}
%{_sbindir}/%{dprog}-wrapper
%dir %{_datadir}/%{name}
%config(noreplace) %{_datadir}/%{name}/scripts
%dir %{_datadir}/%{name}/sql
%{_mandir}/man1/%{name}.1*
%{_mandir}/man1/dspam_*.1*
%attr(750,%{name},root) %dir %{_localstatedir}/log/%{name}
%attr(750,%{name},mail) %dir %{_localstatedir}/spool/%{name}
%attr(750,%{name},mail) %{_localstatedir}/spool/%{name}/data
%attr(640,%{name},%{name}) %config(noreplace) %{_localstatedir}/spool/%{name}/default.prefs
%config(noreplace) %{_localstatedir}/spool/%{name}/txt

%files devel
%defattr(-,root,root)
%{_includedir}/%{name}
%{_libdir}/libdspam.*a
%{_libdir}/libdspam.so
%{_libdir}/%{name}/libhash_drv.*a
%{_libdir}/%{name}/libmysql_drv.*a
%{_libdir}/%{name}/libpgsql_drv.*a
%{_libdir}/pkgconfig/%{name}.pc
%{_mandir}/man3/dspam_*.3*
%{_mandir}/man3/libdspam.3*

%files libs
%defattr(-,root,root)
%doc LICENSE
%{_libdir}/libdspam.so.*
%dir %{_libdir}/%{name}

%files mysql
%defattr(-,root,root)
%{_libdir}/%{name}/libmysql_drv.so
%{_libdir}/%{name}/libmysql_drv.so.*
%config(noreplace) %{_datadir}/%{name}/sql/mysql

%files pgsql
%defattr(-,root,root)
%{_bindir}/dspam_pg2int8
%{_libdir}/%{name}/libpgsql_drv.so
%{_libdir}/%{name}/libpgsql_drv.so.*
%config(noreplace) %{_datadir}/%{name}/sql/pgsql

%files web
%defattr(-,root,root)
%attr(640,root,%{name}) %config(noreplace) %{_sysconfdir}/%{name}/webui.conf
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf
%{_initrddir}/%{wprog}
%{_sbindir}/%{wprog}
%dir %{_datadir}/%{name}/webui
%attr(-,root,%{name}) %config(noreplace) %{_datadir}/%{name}/webui/cgi-bin
%{_datadir}/%{name}/webui/htdocs
%{_datadir}/%{name}/webui/server


%changelog
* Fri Mar 19 2010 Peter Pramberger <peterpramb@member.fsf.org> - 3.9.0-3
- Fixed paths in dspam_maintenance

* Thu Mar 18 2010 Peter Pramberger <peterpramb@member.fsf.org> - 3.9.0-2
- Added missing templates for Web UI

* Thu Mar 11 2010 Peter Pramberger <peterpramb@member.fsf.org> - 3.9.0-1
- Upgrade version (3.9.0)

* Mon Apr 06 2009 Peter Pramberger <peterpramb@member.fsf.org> - 3.8.0-12
- Added further fixes

* Tue Mar 31 2009 Peter Pramberger <peterpramb@member.fsf.org> - 3.8.0-10
- Added fixes for cssclean and dspam_2sql

* Fri Dec 26 2008 Peter Pramberger <peterpramb@member.fsf.org> - 3.8.0-9
- Added Hugo Monteiro's external lookup patch
- Added config file for Web UI

* Thu Dec 25 2008 Peter Pramberger <peterpramb@member.fsf.org> - 3.8.0-8
- Fixed several permission issues

* Fri Nov 07 2008 Peter Pramberger <peterpramb@member.fsf.org> - 3.8.0-7
- Redesigned Web UI infrastructure
- Made user runtime configurable
- Rewritten for buildsystem

* Mon Oct 15 2007 peter.pramberger@member.fsf.org 3.8.0-6
- new version (3.8.0)

* Tue Feb 27 2007 peter.pramberger@member.fsf.org 3.6.8-5
- some spec file cleanups (x86_64 support)

* Thu Dec 21 2006 peter.pramberger@member.fsf.org 3.6.8-4
- created
